Deadlock detection - dldec
================================================

The OMNeT++ simulator is event based. It stops simulating when a time limit is reached or no events are send anymore. 
However, the IB flit simulator has period events to probe the ports for new messages. The simulation will not stop because events are still sent. We need to parse the vector file in order to detect the state of the ports and stop the simulation when a deadlock configuration is found. 
Deadlock detection with dldec runs in parallel with the OMNeT++ InfiniBand Simulation and stops the simulation when a deadlock is found. 

'dldec' parses the vector file of a running simulation. It has two mechanisms to detect a deadlock:  
- By Timeout: A deadlock is found if the vector file has no new entry within 2 seconds.
- By Port filter: One can define a port filter. A deadlock is found if all ports in the filter have 0 credits. 

When 'dldec' has found a deadlock, it concludes the computation and produces for every port a data file where it stores the credits/time pair. The credit were filtered from the vector file before. 

Finally, a `gnuplot` file is created to include all data files for one big graph. 
Run `gnuplot plot.plt` to see how credits have evolved over time for each port.

### Requirements: 
Please install: 
- `node.js`
- `gnuplot` 

### Installation: 

	$ cd <dldec folder>
	$ npm install -S


## Run

For a list of all available options run `node dldec -h`:

	$ node dldec -h
	
	Usage:
  		dldec [OPTIONS] [ARGS]

	Options: 
  		-i, --vector_file [STRING] Path to omnet++ vector file. 
  		-p, --pid [STRING]     PID of ib_flit_sim
  		-f, --pathfilter [STRING] Path to port filter file 
  		-h, --help             Display help and usage details


> **Note:** `dldec` starts automatically when the user invokes a simulation with `./run.sh -t`. 

## Stop

Press any key to conclude the evaluation. The program closes all file streams; this takes some time. The results are plot files for every port and a plot.plt for gnuplot





