var App = require('./app');
var fs = require('fs');
/**
 * Load infividual communication patterns from the the 
 * communicatoin directory. 
 * @param {type} app The next app to call on success.
 * @returns {Communication}
 */
function Communication( app ){
    App.call(this, app);
      
    this.start = function(options){
        // delete port filter file if it exists. 
        if(fs.existsSync('./build/portfilter.json')){
            fs.unlinkSync('./build/portfilter.json');
        }
        
        console.log("--> Communication pattern.");
        
        var Pattern = require('../communication/'+options.communication_pattern);
        var cp = new Pattern(options, options.communication_args);
        options.dst_list = cp.list;
        
        this.callNext(options);
    };       
}

// JS OOP style to inherit methods from the parent class. 
// Set the "constructor" property to refer to this class.
Communication.prototype = Object.create(App.prototype); 
Communication.prototype.constructor = Communication;

module.exports = Communication;