var App = require('./app');
var fs = require('fs');

/**
 * Each omnet++ project folder has an info.txt file with the creation 
 * arguments of the project.
 * @param {App} app Next app to be called, usually null, since this app 
 *                  is the last one to call. 
 * @returns {nm$_info.Info}
 */
function Info(app) {
    App.call(this, app);

    this.start = function (options) {

        console.log("--> Create Resume.");

        fileName = options.projectRootDir + "/info.txt";
        var currentDate = new Date();
        var day = currentDate.getDate();
        var month = currentDate.getMonth() + 1;
        var year = currentDate.getFullYear();
        var content = "Configuration " + day + "/" + month + "/" + year + "\n\n";
        content += "Routing:\t\t" + options.routing_name + "\n";
        content += "Topology:\t\t" + options.topology_name + " (" + options.topology_args + ")\n";
        content += "Pattern:\t\t" + options.communication_pattern + " (" + options.communication_args + ")" + "\n";
        fs.writeFileSync(fileName, content);  
        console.log("** DLGEN finished successfully! **");
        
        if (options.exit) {
            process.exit(0);
        }
    };
}

// JS OOP style to inherit methods from the parent class. 
// Set the "constructor" property to refer to this class.
Info.prototype = Object.create(App.prototype);
Info.prototype.constructor = Info;

module.exports = Info;
