var App = require('./app');

/**
 * Load a topology generator from the topology folder.
 * This function does not inherit from the App class. 
 * The topology app is the entry point of the app chain. 
 * @param {App} app Next App to be called on success.
 * @param {Object} options 
 * @returns {void}
 */
function Topology( app , options ){
    
    console.log("--> Create topology. ");
    
    var Topology = require('../topologies/'+options.topology_name);
    options.topology = Topology(options.topology_args, options);
    
    options.countS = 0;
    options.countH = 0;
    for(var i in options.topology){
        if(!options.topology[ i ].is_host){
            options.countS++;
        }else{
             options.countH++;
        }
    }
    
    
    // call next app.
    app.callThis( options );
}

module.exports = Topology;