var fs = require('fs');


function Deadlock(options, nothing){
    this.topology = options.topology;
    this.routing = options.routing;
       
    this.list = {};
    this.cdg = {};
    
    
    this.max_host = 0;
  
    this.get_max_host_id = function ( ){
        var max = 0;
        for(var i in this.topology){
            var id =  this.topology[i].id;
            if( id > max &&  this.topology[i].is_host ){
                max = id;
            }
        }
        return max;
    };
    
    this.updateCDG = function(src, dst){

        var srcdst = src.name + dst.name;
        var channel_head = {
            'channelID': 0,
            'linklist' : null,
            'status' : null,
            'visited' : 0,
            'pre' : null
        };
        
        var last_channel = channel_head;
        var remote_node = src.port[ 0 ];
        var remote_lid,  remote_port,  local_node,
             local_port,  local_lid, channel;
     
        while (remote_node && !remote_node.is_host){
          //  console.log('start');
            local_node = remote_node;
           
            local_port = this.routing[ local_node.id ][ dst.name ].port - 1;
           // console.log(this.routing);
           //console.log(local_node);
           // console.log(local_port);
            
            local_lid = local_node.name;
            
            remote_node = local_node.port[ local_port ];
            
            if (!remote_node || remote_node.is_host){
                break;
            }

            remote_lid = remote_node.name;
            remote_port = remote_node.port.indexOf(local_node);
            
            var channelID = "" + local_lid + local_port + remote_lid + remote_port;
           
            channel = this.cdg[ channelID ];
            
            if (channel){ // channel found
               //  console.log('hier3');
                var linklist = last_channel.linklist;
                while (linklist && 
                        linklist.node != channel && 
                        linklist.next){
                    linklist = linklist.next;
                }
               //  console.log('hier4');
                if (linklist){
                 //    console.log('hier5');
                    if (linklist.node == channel){
                       //  console.log('hier7');
                        // throw'j';
                        linklist.srcdest[ srcdst ] = {'s': src, 'd': dst};
                    } else{
                   //      console.log('hier6');
                        linklist.next = {
                            'node': channel,
                            'srcdest' : {},
                            'next' : null
                        };
                        linklist.next.srcdest[ srcdst ] = {'s': src, 'd': dst};
                       
                    }
                } else{
                  //   console.log('hier8');
                    last_channel.linklist = {
                        'node': channel,
                        'srcdest' : {},
                        'next' : null
                    };
                    last_channel.linklist.srcdest[ srcdst ] = {'s': src, 'd': dst};
                }
            } else{
              //   console.log('hier9');
                channel = {
                    'channelID': channelID,
                    'device' : local_node,
                    'info' : { 'local_lid': local_lid,
                        'local_port' : local_port,
                        'remote_lid' : remote_lid,
                        'remote_port': remote_port},
                    'linklist' : null,
                    'status' : null,
                    'visited' : 0,
                    'pre' : null
                };
                this.cdg[ channelID ] = channel;
                linklist = last_channel.linklist;
               // console.log('hier');
                while (linklist && linklist.next){
                    linklist = linklist.next;
                }
                //console.log('hier2');
                if (linklist){
                    linklist.next = {
                        'node': channel,
                        'srcdest' : {},
                        'next' : null
                    };
                    linklist.next.srcdest[ srcdst ] = {'s': src, 'd': dst};
                  
                } else{
                    last_channel.linklist = {
                        'node': channel,
                        'srcdest' : {},
                        'next' : null
                    };
                    last_channel.linklist.srcdest[ srcdst ] = {'s': src, 'd': dst};
                }
            }
            last_channel = channel;
        }

        channel_head = null;
    };
     
    
    this.channel_id = null;
    
    this.compute = function(){
        var max_host = this.get_max_host_id();
        var hosts = [];
        for (var i in this.topology){
            if (this.topology[ i ].is_host){
                hosts.push(this.topology[ i ]);
            }
        }

        //scr dst pairs
        for (var i in hosts){
            for (var j in hosts){
                var src = hosts[i];
                var dst = hosts[j];
                if(src !== dst){
                   // console.log('--> Add ' + src.name + " - " + dst.name);
                    this.updateCDG(src, dst);
                }
            }
        }
        
      
        
        this.channel_id = Object.keys(this.cdg);
        // search cycle in cdg
        var cycle = this.search_cycle_in_channel_dep_graph(this.cdg[ this.channel_id[0] ]);
        
        if (cycle){
            console.log("--> Cycle found !");
            // siolate links
            var sdl = {};
            var current = cycle;
            var portfilter = {};
            var used_dest  = [];
            do{
                //current.status = null;
                link = current.linklist;
                while (link) {
                    if (link.node.status === 'GRAY') {
                        current = link.node;
                        
                        for(var j in link.srcdest){
                            sdl[ j ] = link.srcdest[ j ];
                        }
                        
                        // save path filter file for dldec
                        portfilter[ current.info.local_lid ] = current.info.local_port;
                        
                        // filter out all hosts which are part of the ring
                        for(var i in current.device.port){
                            if( current.device.port[i].is_host ){
                                used_dest.push( current.device.port[i].id );
                            }
                        }
                        
                        break;
                    }
                    link = link.next;
                }

            }while(current != cycle);
            
            var data = JSON.stringify(portfilter, null, 4);
            fs.writeFileSync('./build/portfilter.json', data);
            
            
            console.log('--> Cycle isolated');    
            // communicate in cycle
            var used_hosts = [];
           
            for(var a in sdl){
                
                if( this.list[ sdl[a].s.id ] === undefined ){
                    this.list[ sdl[a].s.id ] = [];
                    this.list[ sdl[a].s.id ].push(  sdl[a].d.id );
                    
                    used_hosts.push( sdl[a].s.id );
                }
               
            }
            var max = used_dest.length;
            // remaning hosts are assigned random
            var r = 0;
            for(var b = 1 ; b <= max_host; b++){
                if(used_hosts.indexOf( b ) < 0){
                   
                    var hid = used_dest[ r++ % max ];
                    while(hid === b){
                        // avoid self sending.
                        hid = used_dest[ r++ % max ];
                    }
                
                    if( this.list[ b ] === undefined ){
                        this.list[ b ] = [];
                    }
                
                    this.list[ b ].push( hid );
                }
            }
                
        } else{
            console.log("--> !! Topology has no cycles !!");
            console.log("--> Random assignment.");
          
            for(var i in this.topology){
                if(  this.topology[i].is_host ){
                    var host = this.topology[i];
                
                    var hid = Math.floor((Math.random() * max_host ) + 1); 
                    while(hid === host.id){
                        // avoid self sending.
                        hid = Math.floor((Math.random() * max_host ) + 1); 
                    }
                
                    if( this.list[ host.id ] === undefined ){
                        this.list[ host.id ] = [];
                    }
                
                    this.list[ host.id ].push( hid );
                }
            } 
        }
    };
        
        
    this.search_cycle_in_channel_dep_graph = function(start_node){
        var cycle = null;
        var current = start_node;
        var next_node = null;
        var tmp = null;
        var link = null;
        
        while (current) {

            current.status = 'GRAY';
            link = current.linklist;
            next_node = null;
                
            while (link) {
                if (link.node.status === null) {
                    next_node = link.node;
                    break;
                }
            
                if (link.node.status === 'GRAY') {
                    cycle = link.node;
                    return cycle;
                }
        
                link = link.next;
            }
        
            if (next_node) {
                next_node.pre = current;
                current = next_node;
            } else {
                current.status = 'BLACK';
                
                link = current.linklist;
                while (link) {
                    link.srcdest = {};
                    link = link.next;
                }

                if (current.pre) {
                    tmp = current;
                    current = current.pre;
                    tmp.pre = null;
                } else {
                /* search for other subgraphs in cdg */

                    current = this.get_next_cdg_node();
                    if (!current)
                        break; /* all relevant nodes traversed, no more cycles found */
                }
            }
        }
        return cycle;
    };
        
    this.get_next_cdg_node = function(){       
        var chid = this.channel_id;
        var current, res = null;
        
        for (var i in chid){
            current = this.cdg[ chid[i] ];
            if (current){
                current.visited = 1;
                if (current.status === null) {
                    res = current;
                    break;
                }
            }
        }

        /* Clean up */
        for (var i in chid){
            current = this.cdg[ chid[i] ];
            if (current){
                current.visited = 0;
            }
        }

        return res;
    };

    this.compute();
};
module.exports = Deadlock;
