var Switch  = require('../components/switch');
var Host    = require('../components/host');
var fs      = require('fs');

function File( args ,options){
    
    var check = /\d+;\w+/;
    var OK = check.exec(args);  
    if( !OK ){
        console.log('-E- File module invalid argument: '+args);
        console.log('-E- Use the following options (no spaces in "name"): -a <number>;<name>');
        console.log('-E- Abort.');
        process.exit( 0 );
    }
    
    var parts = args.split(";");
    var filename = parts[1];
    var n_hosts = parts[0] ;
    
    var topology = [];
    var swlist   = {};
    
     if(!fs.existsSync('topologies/file/'+filename)){
        console.log('-E- No file found: ' + 'topologies/file/'+filename);
        console.log('-E- Abort.');
        process.exit( 0 );
    }
    
    var data = fs.readFileSync('topologies/file/'+filename);   
    var nodes = data.toString().replace(/\n/g, ',').split(',');
    var sw1 , sw2;
    // skip first line
    var id = 0;
    for(var i = 2 ; i < nodes.length; i += 2){
        sw1 = parseInt( nodes[ i ] );
        sw2 = parseInt( nodes[ i + 1 ] ); 
        if(!(sw1 && sw2) ){
            break;
        }
        
        if(swlist[sw1] === undefined){
            swlist[sw1] = new Switch( id++ );
            topology.push( swlist[sw1] );
        }

        if(swlist[sw2] === undefined){
            swlist[sw2] = new Switch( id++ );
            topology.push( swlist[sw2] );
        }

        swlist[sw1].add( swlist[sw2]);     
    }       
        
    var hNodes = [];
    n_hosts = n_hosts * topology.length;
    for(var i = 0; i < n_hosts; i++){
        hNodes.push( new  Host( i + 1 ) );
    }

    // connect host in round robin 
    // and set comunication partner
    for(var i = 0; i < n_hosts; i++){
        topology[ i % topology.length].add( hNodes[i] );
    }
    
    for(var h in hNodes){
        topology.push( hNodes[ h ] );
    }
    
    return topology;
}

module.exports = File;