var fs = require('fs');

function create_FDBS_File(fileName, routing){
    var content = "";

    var i = 0;
    for(var n in routing){
        content += i + ": ";
       
        // we asume all hosts are continuously enumarated from 0 to n 
        // getting the max host id indicates how many entries a swich line needs.
        // prefill an array with 255 and fill up the gaps. 
        // it might be possible? that not all switchs know all hosts.
        var max_host = get_max_host_id( routing[n]); 
        var table = Array.apply(null, Array(max_host)).map(Number.prototype.valueOf,255);
        
        for(var e in routing[n]){
            var entry = routing[n][e];
            table[ entry.host_id  ] = entry.port - 1; // in omnet++, ports begin at index zero
        }
        
        for(var e in table){
             content += table[ e ]+ ' ';
        }
        
        content += "\n";
        i++;
    }
    fs.writeFileSync(fileName, content);
}
exports.create_FDBS_File = create_FDBS_File;

function get_max_host_id( route_table ){
    var max = 0;
    for(var i in route_table){
        var id = route_table[i].host_id;
        if( id > max ){
            max = id;
        }
    }
    return max;
}

function create_FDBS_ini_File(fileName, routing){
    var content = "[General]\n\n";
   
    var i = 0;
    for(var n in routing){       
        content += "**.SW_"+n+".**.fdbIndex = "+ (i++) + "\n";
    }
    fs.writeFileSync(fileName, content);
}
exports.create_FDBS_ini_File = create_FDBS_ini_File;

function create_omnet_File(fileName, netname , append){
    var data = fs.readFileSync('assets/omnetpp.ini');
    data =  "[General]\n" + "network = "+netname+"\n"+ data;
    
    data = data + append;
    
    fs.writeFileSync(fileName, data);
    
}
exports.create_omnet_File = create_omnet_File;

function copy_File(srcFileName, destFileName, options){
    
    var data = fs.readFileSync(srcFileName).toString();
    if(options !== undefined){
        for(var i in options.config){
            data = data.replace("%%"+i+"%%",options.config[i]);
        }
    }
    fs.writeFileSync(destFileName, data);
    
}
exports.copy_File = copy_File;

function create_NED_File(fileName, network, topology){
    
    
    var content = "import ib_model.*"+ ";\n\n";
    content += "network "+ network + "{\n";
    content += "\t submodules:" + "\n";
    
    // add hosts
    for( var i in topology ){
        var device = topology[i];
        if( device.is_host  ){
            content += "\t\t "+ device.name + ": HCA{" + "\n" +
                "\t\t parameters: \n" + 
                    "\t\t\t srcLid = " + device.id + ";" + "\n" +
                "\t\t }\n";
        }else{
            content += "\t\t " + device.name +": Switch {"+ "\n" +
            "\t\t parameters:"+ "\n" +
                "\t\t\t numSwitchPorts =" + device.max_ports + ";"+ "\n" +
                "\t\t\t @display(\"i=abstract/router\");"+ "\n" +
            "\t\t gates:"+ "\n" +
                "\t\t\t port["+ device.max_ports +"];" + "\n" +
            "\t\t }\n";
        }

    }
    // store already used devices, to avoid duplication
    used_device = {};
    content += "\t connections:" + "\n";
    // add connections
    for( var i in topology ){
        var device = topology[i];
       
        var head, tail;
       

        for( var n in device.port){

             if( used_device[ device.name  ] !== undefined && used_device[ device.name  ].indexOf(device.port[n].name) > -1){
                 continue;
             }

             if(device.is_host){
                 head = device.name+".port ";
             }else{
                 head = device.name+".port["+n+"]";
             }

             if( device.port[n].is_host ){
                 tail = device.port[n].name+".port; \n";
             }else{
                 tail = device.port[n].name + '.port[' +device.port[n].port.indexOf(device) + "];\n";
             }
             content += head + " <-->  IB4XQDRWire <--> " + tail;

             if( used_device[ device.port[n].name ] === undefined){
                used_device[ device.port[n].name ] = [];
             }
             used_device[ device.port[n].name ].push( device.name );
        }
       
    }
   
    content += "}" + "\n";
    
    fs.writeFileSync(fileName, content);
}
exports.create_NED_File = create_NED_File;


function create_dst_sequence_ini_file(fileName, topology){
    var content = "[General]\n\n";
    for( var n in topology){
        var device = topology[n];
        if(device.is_host){
           content +=  "**"+device.name+".app.dstSeqVecIdx  = "+device.id+"\n";
        }
    }
    
    fs.writeFileSync(fileName, content);
}
exports.create_dst_sequence_ini_file = create_dst_sequence_ini_file;

function create_dst_sequence_file(fileName, dst_list){
 
    var content = "";
    for( var n in dst_list){
        var entry = dst_list[ n ];  
        content += n+":   ";
        for( var i in entry){
            content += entry[i] + " ";
        }
        content += "\n";
    }
    
    fs.writeFileSync(fileName, content);
}

exports.create_dst_sequence_file = create_dst_sequence_file;


// Note: Works currently only for the jumps
exports.sl_routing = function(options){
   
    //var maxVL = 0;

    var content = "";
    
    for(var i in options.dst_list){
        var srcLid = options.HostByID[ i ].lid;
        var dstLid = options.HostByID[ options.dst_list[ i ][ 0 ] ].lid;
        var srcName = options.HostByID[ i ].name;
        content += "\n**" + srcName + ".app.msgSQ = "+
                options.pathSL[ srcLid ][ dstLid ] +"";
    }
    
    var result  = content + 
            '\n\n[Config df]\n' +
            'repeat=1\n'+
            '**.H**.sl2vlFile = "host_sl2vl_df.txt"\n'+
            '**.SW**.sl2vlFile = "switch_sl2vl_df.txt"\n' +
            content;
    
    //maxVL++;
    //content += "\n**.maxVL = "+(maxVL);
    //exports.maxVL = maxVL; // Make maxVL global
    //#**H_0.app.msgSQ = 1
    //#**H_1.app.msgSQ = 1  
    return result;
};

exports.create_sl2vl_file = function(rootFolder , options){
    var T = options.topology;
    
    var std_pattern = "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 7";
    var df_pattern = "0 1 2 3 4 5 6 7 0 1 2 3 4 5 6 7";
    
    var content = "";
    for( var i in T){
        if(T[ i ].is_host){
            content += T[ i ].id + " 0 0 " + std_pattern + "\n"; 
        }
    }
    fs.writeFileSync(rootFolder + "/host_sl2vl.txt", content);
    
    content = "";
    for( var i in T){
        if(!T[ i ].is_host){
            for(var j in T[i].port){ // in 
                for(var k in T[i].port){ // out
                    if(i !== j){
                       content += T[ i ].id + " " + j + " " + k +" " + std_pattern + "\n"; 
                    }
                }
            } 
        }
    }
    fs.writeFileSync(rootFolder + "/switch_sl2vl.txt", content);
    
    content = "";
    for( var i in T){
        if(T[ i ].is_host){
            content += T[ i ].id + " 0 0 " + df_pattern + "\n"; 
        }
    }
    fs.writeFileSync(rootFolder + "/host_sl2vl_df.txt", content);
    
    content = "";
    for( var i in T){
        if(!T[ i ].is_host){
            for(var j in T[i].port){ j = parseInt(j);
                for(var k in T[i].port){ k = parseInt(k);
                    if(i !== j){
                       content += T[ i ].id + " " + j + " " + k +" " + 
                               options.slvl[ T[ i ].id ][j][k] + "\n"; 
                    }
                }
            } 
        }
    }
    fs.writeFileSync(rootFolder + "/switch_sl2vl_df.txt", content);
   
};