#include "ibstop.h"

void Supervisor::printMap(){
 
    EV << "\tTotal size: " << counter.size() << endl; /* Output the size */

    /* Create an iterator, much like vector iterators */

    map <unsigned int, int>::iterator it;

    for (it = counter.begin(); it != counter.end(); ++it) {
        EV << setw(10) << it->first << setw(5) << it->second << endl;
    }
 
}
 
void Supervisor::insert(unsigned int LID,  int msg_count){
    
    counter[ LID ] += msg_count;
    printMap();
}

void Supervisor::probe(){
    bool found = true;
    map <unsigned int, int>::iterator it;
    for (it = counter.begin(); it != counter.end(); ++it) {
        found &= it->second <= 0;
    }
    if(found){
        EV << "Finish now!";
        opp_terminate( "All Messages have arrived." );
    }
}

void Supervisor::update(unsigned int LID){
    counter[ LID ]--;
    printMap();
    probe();
}
